# Null type

class pyasn1.type.univ.Null(value=NoValue(), tagSet=TagSet())

  Create Null schema or value object.

  Null class is based on `SimpleAsn1Type`, its objects are immutable and duck-type Python `str` objects (always empty).

  Keyword Arguments:

    - value (`str` or Null object) – Python empty `str` literal or any object that evaluates to `False` If value is not given, schema object will be created.

    - tagSet (`TagSet`) – Object representing non-default ASN.1 tag(s)

  Raises:

    ValueConstraintError, PyAsn1Error – On constraint violation or bad initializer.

  Examples

      class Ack(Null):
          '''
          ASN.1 specification:

          Ack ::= NULL
          '''
      ack = Ack('')

  Note

  The Null type models ASN.1 NULL.

  clone(value=NoValue(), tagSet=TagSet())

    Create a modified version of Null schema or value object.

    The clone() method accepts the same set arguments as Null class takes on instantiation except that all arguments of the clone() method are optional.

    Whatever arguments are supplied, they are used to create a copy of self taking precedence over the ones used to instantiate self.

    Note

    Due to the immutable nature of the Null object, if no arguments are supplied, no new Null object will be created and self will be returned instead.

  subtype(value=NoValue(), implicitTag=Tag(), explicitTag=Tag())

    Create a specialization of Null schema or value object.

    The subtype relationship between ASN.1 types has no correlation with subtype relationship between Python types. ASN.1 type is mainly identified by its tag(s) (`TagSet`) and value range constraints (`ConstraintsIntersection`). These ASN.1 type properties are implemented as Null attributes.

    The subtype() method accepts the same set arguments as Null class takes on instantiation except that all parameters of the subtype() method are optional.

    With the exception of the arguments described below, the rest of supplied arguments they are used to create a copy of self taking precedence over the ones used to instantiate self.

    The following arguments to subtype() create a ASN.1 subtype out of Null type:

    Other Parameters:

      - implicitTag (`Tag`) – Implicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - explicitTag (`Tag`) – Explicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - subtypeSpec (`ConstraintsIntersection`) – Add ASN.1 constraints object to one of the self’s, then use the result as new object’s ASN.1 constraints.

    Returns:

      new instance of Null schema or value object

    Note

    Due to the immutable nature of the Null object, if no arguments are supplied, no new Null object will be created and self will be returned instead.

  tagSet = <TagSet object, tags 0:0:5>

    Set (on class, not on instance) or return a `TagSet` object representing ASN.1 tag(s) associated with Null type.

  subtypeSpec = <ConstraintsIntersection object, consts <SingleValueConstraint object, consts b''>>

    Set (on class, not on instance) or return a `ConstraintsIntersection` object imposing constraints on Null type initialization values.

  property effectiveTagSet

    For Null type is equivalent to tagSet

  isSameTypeWith(other, matchTags=True, matchConstraints=True)

    Examine Null type for equality with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is Null type, `False` otherwise.

  isSuperTypeOf(other, matchTags=True, matchConstraints=True)

    Examine Null type for subtype relationship with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is a subtype of Null type, `False` otherwise.

  property isValue

    Indicate that Null object represents ASN.1 value.

    If isValue is `False` then this object represents just ASN.1 schema.

    If isValue is `True` then, in addition to its ASN.1 schema features, this object can also be used like a Python built-in object (e.g. `int`, `str`, `dict` etc.).

    Returns:

      `bool` – `False` if object represents just ASN.1 schema. `True` if object represents ASN.1 schema and can be used as a normal value.

    Note

    There is an important distinction between PyASN1 schema and value objects. The PyASN1 schema objects can only participate in ASN.1 schema-related operations (e.g. defining or testing the structure of the data). Most obvious uses of ASN.1 schema is to guide serialisation codecs whilst encoding/decoding serialised ASN.1 contents.

    The PyASN1 value objects can additionally participate in many operations involving regular Python objects (e.g. arithmetic, comprehension etc).

  property tagMap

    Return a `TagMap` object mapping ASN.1 tags to ASN.1 objects within callee object.